﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Diagramming.Wpf;

namespace BrokenLink
{
   /// <summary>
   /// Interaction logic for Container.xaml
   /// </summary>
   public partial class Container
   {
      public Container()
      {
         InitializeComponent();
      }

      /// <inheritdoc/>
      public UIElement ContentControl
      {
         get
         {
            return TheContentControl.Content as UIElement;
         }

         set
         {
            TheContentControl.Content = value;
         }
      }

      private void OnSizeChanged(object sender, SizeChangedEventArgs sizeChangedEventArgs)
      {
         if (ContentControl is ShapeNode shapeNode)
         {
            ResizeShapeNode(shapeNode, sizeChangedEventArgs.NewSize);
         }
      }

      private void ResizeShapeNode(DiagramNode shapeNode, Size newSize)
      {
         shapeNode?.Resize(newSize.Width, newSize.Height);
      }
   }
}
