﻿
namespace BrokenLink
{
   using System;
   using System.Collections.Generic;
   using System.Collections.Specialized;
   using System.ComponentModel;
   using System.Linq;
   using System.Windows;
   using System.Windows.Data;
   using System.Windows.Media;
   using MindFusion.Diagramming.Wpf;

   public class Node : DiagramNodeAdapter
   {
      public Node(NodeControl control) : base(control.AsFrameworkElement())
      {
         GridAlignPoint = new RelativePosition
         {
            X = 50,
            XUnit = UnitType.Percentage,
            Y = 50,
            YUnit = UnitType.Percentage
         };

         SizeSyncMode = SizeSyncMode.SetSize;

         if (Application.Current != null)
         {
            HandleStrokeBrush = Application.Current.TryFindResource("Blue4Brush") as SolidColorBrush;
            HandleFillBrush = Application.Current.TryFindResource("FakeBlue4Brush60") as SolidColorBrush;
         }
      }

      public SolidColorBrush HandleStrokeBrush { get; private set; }

      private SolidColorBrush HandleFillBrush { get; }

      public override void DrawHandles(DrawingContext graphics, HandlesVisualStyle hstyle)
      {
         hstyle.HandlePen = new Pen(HandleStrokeBrush, hstyle.HandlePen.Thickness);
         hstyle.HandleBrush = HandleFillBrush;
         hstyle.RotationHandleBrush = HandleFillBrush;
         base.DrawHandles(graphics, hstyle);
      }

   }
}
